ACTION=="add", KERNEL=="null", OWNER="root", GROUP="root", MODE="0666"
ACTION=="add", KERNEL=="zero", OWNER="root", GROUP="root", MODE="0666"
ACTION=="add", KERNEL=="full", OWNER="root", GROUP="root", MODE="0666"
ACTION=="add", KERNEL=="ptmx", OWNER="root", GROUP="radio", MODE="0666"
ACTION=="add", KERNEL=="tty", OWNER="root", GROUP="root", MODE="0666"
ACTION=="add", KERNEL=="random", OWNER="root", GROUP="root", MODE="0666"
ACTION=="add", KERNEL=="urandom", OWNER="root", GROUP="root", MODE="0666"
ACTION=="add", KERNEL=="hw_random", OWNER="root", GROUP="system", MODE="0440"
ACTION=="add", KERNEL=="ashmem", OWNER="root", GROUP="root", MODE="0666"
ACTION=="add", KERNEL=="binder", OWNER="root", GROUP="root", MODE="0666"
ACTION=="add", KERNEL=="hwbinder", OWNER="root", GROUP="root", MODE="0666"
ACTION=="add", KERNEL=="vndbinder", OWNER="root", GROUP="root", MODE="0666"
ACTION=="add", KERNEL=="pmsg0", OWNER="root", GROUP="log", MODE="0222"
ACTION=="add", KERNEL=="dri/*", OWNER="root", GROUP="android_graphics", MODE="0666"
ACTION=="add", KERNEL=="uhid", OWNER="uhid", GROUP="uhid", MODE="0660"
ACTION=="add", KERNEL=="uinput", OWNER="uhid", GROUP="uhid", MODE="0660"
ACTION=="add", KERNEL=="rtc0", OWNER="system", GROUP="system", MODE="0640"
ACTION=="add", KERNEL=="tty0", OWNER="root", GROUP="system", MODE="0660"
ACTION=="add", KERNEL=="graphics/*", OWNER="root", GROUP="android_graphics", MODE="0660"
ACTION=="add", KERNEL=="input/*", OWNER="root", GROUP="input", MODE="0660"
ACTION=="add", KERNEL=="v4l-touch*", OWNER="root", GROUP="input", MODE="0660"
ACTION=="add", KERNEL=="snd/*", OWNER="system", GROUP="audio", MODE="0660"
ACTION=="add", KERNEL=="bus/usb/*", OWNER="root", GROUP="usb", MODE="0660"
ACTION=="add", KERNEL=="mtp_usb", OWNER="root", GROUP="plugdev", MODE="0660"
ACTION=="add", KERNEL=="usb_accessory", OWNER="root", GROUP="usb", MODE="0660"
ACTION=="add", KERNEL=="tun", OWNER="system", GROUP="vpn", MODE="0660"
ACTION=="add", KERNEL=="ppp", OWNER="radio", GROUP="vpn", MODE="0660"
ACTION=="add", KERNEL=="block/mmcblk0", OWNER="root", GROUP="system", MODE="0660"
ACTION=="add", KERNEL=="block/mmcblk0boot0", OWNER="root", GROUP="system", MODE="0660"
ACTION=="add", KERNEL=="block/mmcblk0boot1", OWNER="root", GROUP="system", MODE="0660"
ACTION=="add", KERNEL=="misc-sd", OWNER="root", GROUP="system", MODE="0660"
ACTION=="add", KERNEL=="block/sda", OWNER="root", GROUP="system", MODE="0660"
ACTION=="add", KERNEL=="block/sdb", OWNER="root", GROUP="system", MODE="0660"
ACTION=="add", KERNEL=="block/sdc", OWNER="root", GROUP="system", MODE="0660"
ACTION=="add", KERNEL=="block/platform/bootdevice/by-name/misc2", OWNER="root", GROUP="system", MODE="0660"
ACTION=="add", KERNEL=="block/platform/bootdevice/by-name/boot", OWNER="root", GROUP="system", MODE="0640"
ACTION=="add", KERNEL=="block/platform/bootdevice/by-name/recovery", OWNER="root", GROUP="system", MODE="0640"
ACTION=="add", KERNEL=="block/platform/bootdevice/by-name/secro", OWNER="root", GROUP="system", MODE="0640"
ACTION=="add", KERNEL=="block/platform/bootdevice/by-name/seccfg", OWNER="root", GROUP="system", MODE="0660"
ACTION=="add", KERNEL=="block/platform/bootdevice/by-name/proinfo", OWNER="root", GROUP="system", MODE="0660"
ACTION=="add", KERNEL=="block/platform/bootdevice/by-name/nvram", OWNER="root", GROUP="system", MODE="0660"
ACTION=="add", KERNEL=="block/platform/bootdevice/by-name/para", OWNER="root", GROUP="system", MODE="0660"
ACTION=="add", KERNEL=="block/platform/bootdevice/by-name/logo", OWNER="root", GROUP="system", MODE="0660"
ACTION=="add", KERNEL=="block/platform/bootdevice/by-name/frp", OWNER="root", GROUP="system", MODE="0660"
ACTION=="add", KERNEL=="block/platform/bootdevice/by-name/md1img", OWNER="root", GROUP="system", MODE="0640"
ACTION=="add", KERNEL=="block/platform/bootdevice/by-name/md1img_a", OWNER="root", GROUP="system", MODE="0640"
ACTION=="add", KERNEL=="block/platform/bootdevice/by-name/md1img_b", OWNER="root", GROUP="system", MODE="0640"
ACTION=="add", KERNEL=="block/platform/bootdevice/by-name/md1dsp", OWNER="root", GROUP="system", MODE="0660"
ACTION=="add", KERNEL=="block/platform/bootdevice/by-name/boot_para", OWNER="root", GROUP="system", MODE="0640"
ACTION=="add", KERNEL=="otp", OWNER="system", GROUP="system", MODE="0660"
ACTION=="add", KERNEL=="block/platform/bootdevice/by-name/otp", OWNER="root", GROUP="system", MODE="0660"
ACTION=="add", KERNEL=="stpwmt", OWNER="system", GROUP="system", MODE="0660"
ACTION=="add", KERNEL=="wmtdetect", OWNER="system", GROUP="system", MODE="0660"
ACTION=="add", KERNEL=="fw_log_wmt", OWNER="system", GROUP="system", MODE="0660"
ACTION=="add", KERNEL=="stpbt", OWNER="bluetooth", GROUP="bluetooth", MODE="0660"
ACTION=="add", KERNEL=="fw_log_bt", OWNER="bluetooth", GROUP="bluetooth", MODE="0660"
ACTION=="add", KERNEL=="stpgps", OWNER="gps", GROUP="gps", MODE="0660"
ACTION=="add", KERNEL=="gps", OWNER="gps", GROUP="system", MODE="0660"
ACTION=="add", KERNEL=="fw_log_gps", OWNER="gps", GROUP="gps", MODE="0660"
ACTION=="add", KERNEL=="gps_emi", OWNER="gps", GROUP="gps", MODE="0660"
ACTION=="add", KERNEL=="stpant", OWNER="system", GROUP="system", MODE="0660"
ACTION=="add", KERNEL=="wmtWifi", OWNER="radio", GROUP="radio", MODE="0660"
ACTION=="add", KERNEL=="fw_log_wifi", OWNER="wifi", GROUP="wifi", MODE="0660"
ACTION=="add", KERNEL=="fm", OWNER="root", GROUP="android_media", MODE="0660"
ACTION=="add", KERNEL=="msr3110", OWNER="root", GROUP="root", MODE="0666"
ACTION=="add", KERNEL=="mt6605", OWNER="nfc", GROUP="radio", MODE="0660"
ACTION=="add", KERNEL=="st21nfc", OWNER="nfc", GROUP="radio", MODE="0660"
ACTION=="add", KERNEL=="btif", OWNER="system", GROUP="system", MODE="0600"
ACTION=="add", KERNEL=="trusty-ipc-dev0", OWNER="system", GROUP="system", MODE="0660"
ACTION=="add", KERNEL=="block/mmcblk0rpmb", OWNER="root", GROUP="system", MODE="0660"
ACTION=="add", KERNEL=="mobicore", OWNER="system", GROUP="system", MODE="0600"
ACTION=="add", KERNEL=="mobicore-user", OWNER="system", GROUP="system", MODE="0666"
ACTION=="add", KERNEL=="t-base-tui", OWNER="system", GROUP="system", MODE="0666"
ACTION=="add", KERNEL=="bus/usb/*", OWNER="root", GROUP="usb", MODE="0660"
ACTION=="add", KERNEL=="ttyUSB0", OWNER="radio", GROUP="radio", MODE="0660"
ACTION=="add", KERNEL=="ttyUSB1", OWNER="radio", GROUP="radio", MODE="0660"
ACTION=="add", KERNEL=="ttyUSB2", OWNER="radio", GROUP="radio", MODE="0660"
ACTION=="add", KERNEL=="ttyUSB3", OWNER="radio", GROUP="radio", MODE="0660"
ACTION=="add", KERNEL=="ttyUSB4", OWNER="radio", GROUP="radio", MODE="0660"
ACTION=="add", KERNEL=="log/ksystem", OWNER="root", GROUP="log", MODE="0600"
ACTION=="add", KERNEL=="ccci*", OWNER="radio", GROUP="radio", MODE="0660"
ACTION=="add", KERNEL=="ttyC*", OWNER="radio", GROUP="radio", MODE="0660"
ACTION=="add", KERNEL=="eemcs*", OWNER="radio", GROUP="radio", MODE="0660"
ACTION=="add", KERNEL=="emd*", OWNER="radio", GROUP="radio", MODE="0660"
ACTION=="add", KERNEL=="ccci_pcm_rx", OWNER="root", GROUP="audio", MODE="0660"
ACTION=="add", KERNEL=="ccci_pcm_tx", OWNER="root", GROUP="audio", MODE="0660"
ACTION=="add", KERNEL=="ccci_aud", OWNER="root", GROUP="audio", MODE="0660"
ACTION=="add", KERNEL=="ccci2_aud", OWNER="root", GROUP="audio", MODE="0660"
ACTION=="add", KERNEL=="ccci3_aud", OWNER="root", GROUP="audio", MODE="0660"
ACTION=="add", KERNEL=="ccci_raw_audio", OWNER="root", GROUP="audio", MODE="0660"
ACTION=="add", KERNEL=="ccci3_raw_audio", OWNER="root", GROUP="audio", MODE="0660"
ACTION=="add", KERNEL=="eemcs_aud", OWNER="root", GROUP="audio", MODE="0660"
ACTION=="add", KERNEL=="irtx", OWNER="system", GROUP="system", MODE="0660"
ACTION=="add", KERNEL=="ir-learning", OWNER="system", GROUP="system", MODE="0660"
ACTION=="add", KERNEL=="pvrsrvkm", OWNER="root", GROUP="root", MODE="0666"
ACTION=="add", KERNEL=="pvr_sync", OWNER="root", GROUP="root", MODE="0666"
ACTION=="add", KERNEL=="mtgpio", OWNER="radio", GROUP="root", MODE="0600"
ACTION=="add", KERNEL=="ttySDIO*", OWNER="radio", GROUP="sdcard_rw", MODE="0660"
ACTION=="add", KERNEL=="ttyRB*", OWNER="radio", GROUP="radio", MODE="0660"
ACTION=="add", KERNEL=="mali", OWNER="system", GROUP="android_graphics", MODE="0666"
ACTION=="add", KERNEL=="ion", OWNER="system", GROUP="android_graphics", MODE="0666"
ACTION=="add", KERNEL=="lightsensor", OWNER="system", GROUP="system", MODE="0664"
ACTION=="add", KERNEL=="touch", OWNER="root", GROUP="system", MODE="0660"
ACTION=="add", KERNEL=="hotknot", OWNER="root", GROUP="system", MODE="0660"
ACTION=="add", KERNEL=="RT_Monitor", OWNER="system", GROUP="system", MODE="0600"
ACTION=="add", KERNEL=="kick_powerkey", OWNER="system", GROUP="system", MODE="0600"
ACTION=="add", KERNEL=="ttyACM0", OWNER="radio", GROUP="radio", MODE="0660"

# Manually converted from init.mt6785.rc
ACTION=="add", KERNEL=="scp", OWNER="root", GROUP="system", MODE="0444"
ACTION=="add", KERNEL=="adsp", OWNER="system", GROUP="android_media", MODE="0660"
ACTION=="add", KERNEL=="sspm", OWNER="root", GROUP="system", MODE="0440"
ACTION=="add", KERNEL=="pmem_multimedia", OWNER="system", GROUP="system", MODE="0666"
# CMDQ
ACTION=="add", KERNEL=="mtk_cmdq", OWNER="system", GROUP="system", MODE="0644"
# MDP SYNC
ACTION=="add", KERNEL=="mdp_sync", OWNER="system", GROUP="system", MODE="0644"
# OPEN DSP
ACTION=="add", KERNEL=="audio_ipi", OWNER="root", GROUP="android_media", MODE="0640"
# SmartPA
ACTION=="add", KERNEL=="audio_scp", OWNER="root", GROUP="android_media", MODE="0640"
ACTION=="add", KERNEL=="offloadservice", OWNER="root", GROUP="android_media", MODE="0640"
# VideoCodec
ACTION=="add", KERNEL=="Vcodec", OWNER="system", GROUP="android_media", MODE="0660"
ACTION=="add", KERNEL=="vcu", OWNER="system", GROUP="android_media", MODE="0660"
ACTION=="add", KERNEL=="video0", OWNER="system", GROUP="android_media", MODE="0666"
ACTION=="add", KERNEL=="video1", OWNER="system", GROUP="android_media", MODE="0666"
# Android SEC related device nodes
ACTION=="add", KERNEL=="sec", OWNER="root", GROUP="system", MODE="0660"
# gz device
ACTION=="add", KERNEL=="gz_kree", OWNER="system", GROUP="android_media", MODE="0660"
# Camera
ACTION=="add", KERNEL=="camera-sysram", OWNER="system", GROUP="android_media", MODE="0660"
ACTION=="add", KERNEL=="camera-isp", OWNER="system", GROUP="android_media", MODE="0660"
ACTION=="add", KERNEL=="camera-dip", OWNER="system", GROUP="android_media", MODE="0660"
ACTION=="add", KERNEL=="camera-tsf", OWNER="system", GROUP="android_media", MODE="0660"
ACTION=="add", KERNEL=="camera-dpe", OWNER="system", GROUP="android_media", MODE="0660"
ACTION=="add", KERNEL=="camera-mfb", OWNER="system", GROUP="android_media", MODE="0660"
ACTION=="add", KERNEL=="camera-rsc", OWNER="system", GROUP="android_media", MODE="0660"
ACTION=="add", KERNEL=="camera-owe", OWNER="system", GROUP="android_media", MODE="0660"
ACTION=="add", KERNEL=="camera-fdvt", OWNER="system", GROUP="android_media", MODE="0660"
ACTION=="add", KERNEL=="camera-wpe", OWNER="system", GROUP="android_media", MODE="0660"
ACTION=="add", KERNEL=="camera-pipemgr", OWNER="system", GROUP="android_media", MODE="0660"
ACTION=="add", KERNEL=="kd_camera_hw", OWNER="system", GROUP="android_media", MODE="0660"
ACTION=="add", KERNEL=="seninf", OWNER="system", GROUP="android_media", MODE="0660"
ACTION=="add", KERNEL=="flashlight", OWNER="system", GROUP="camera", MODE="0660"
ACTION=="add", KERNEL=="kd_camera_hw_bus2", OWNER="system", GROUP="android_media", MODE="0660"
ACTION=="add", KERNEL=="FM50AF", OWNER="system", GROUP="android_media", MODE="0660"
ACTION=="add", KERNEL=="CAM_CAL_DRV", OWNER="system", GROUP="android_media", MODE="0660"
ACTION=="add", KERNEL=="MAINAF", OWNER="system", GROUP="android_media", MODE="0660"
ACTION=="add", KERNEL=="MAIN2AF", OWNER="system", GROUP="android_media", MODE="0660"
ACTION=="add", KERNEL=="SUBAF", OWNER="system", GROUP="android_media", MODE="0660"
ACTION=="add", KERNEL=="SUB2AF", OWNER="system", GROUP="android_media", MODE="0660"
# xiaomi algoup
ACTION=="add", KERNEL=="vpu", OWNER="system", GROUP="android_media", MODE="0664"
# CCU
ACTION=="add", KERNEL=="ccu", OWNER="system", GROUP="android_media", MODE="0666"
# VOW
ACTION=="add", KERNEL=="vow", OWNER="system", GROUP="android_media", MODE="0640"
#MDP
ACTION=="add", KERNEL=="mt-mdp, OWNER="system", GROUP="android_media", MODE="0660"
# SMI
ACTION=="add", KERNEL=="MTK_SMI", OWNER="system", GROUP="android_media", MODE="0660"
# DFRC
ACTION=="add", KERNEL=="mtk_dfrc", OWNER="system", GROUP="android_graphics", MODE="0660"
# usip
ACTION=="add", KERNEL=="usip", OWNER="system", GROUP="android_media", MODE="0660"
# UIBC
ACTION=="add", KERNEL=="uibc", OWNER="system", GROUP="system", MODE="0660"
# ANC SERVICE
ACTION=="add", KERNEL=="ancservice", OWNER="system", GROUP="android_media", MODE="0640"
# M4U
ACTION=="add", KERNEL=="m4u", OWNER="system", GROUP="android_media", MODE="0444"
# Add More extra rules from init.mt6785.rc
ACTION=="add", KERNEL=="mtk_jpeg", OWNER="system", GROUP="android_media", MODE="0444"
ACTION=="add", KERNEL=="mtk_disp", OWNER="system", GROUP="android_media", MODE="0660"
ACTION=="add", KERNEL=="TV-out", OWNER="system", GROUP="android_media", MODE="0660"
ACTION=="add", KERNEL=="fb0", OWNER="system", GROUP="android_graphics", MODE="0660"
ACTION=="add", KERNEL=="mtk_disp_mgr", OWNER="system", GROUP="android_graphics", MODE="0660"
ACTION=="add", KERNEL=="sw_sync", OWNER="system", GROUP="android_graphics", MODE="0660"
ACTION=="add", KERNEL=="rfkill", OWNER="system", GROUP="radio", MODE="0660"
ACTION=="add", KERNEL=="radio", OWNER="radio", GROUP="radio", MODE="0770"
ACTION=="add", KERNEL=="spm", OWNER="system", GROUP="system", MODE="0660"
ACTION=="add", KERNEL=="mtk_sched", OWNER="system", GROUP="android_media", MODE="0660"
ACTION=="add", KERNEL=="mtkfb_vsync", OWNER="system", GROUP="android_graphics", MODE="0660"
ACTION=="add", KERNEL=="ebc", OWNER="system", GROUP="android_media", MODE="0660"
# Unmanaged wlan1
ACTION=="add", SUBSYSTEM=="net", KERNEL=="wlan1", ENV{NM_UNMANAGED}="1"

# Enable KVM for all users in phablet
# Ultimately access is mediated by AppArmor
KERNEL=="kvm", GROUP="phablet", MODE="0660"
